#pragma once
#include "Texture.h"

class Animation
{
public:
	Animation(Texture* pTexture, int frames, float frameDuration, Rectf srcRect, bool isLooping = true);

	void Update(float elapsedSec);
	void Draw(const Vector2f& pos) const;
	void Draw(const Vector2f& pos, const Rectf& dst) const;


	void SetPlaying(bool isPlaying);
	void SetFlipped(bool isFlipped);

	void Reset();
	bool IsDone() const;

	int GetFrameCount() const;
	void SetFrame(int frame);

private:
	Texture* m_pTexture;
	Rectf m_SrcRect;

	int m_Frames { 0 };
	int m_CurrentFrame { 0 };
	float m_FrameTimer { 0.0f };

	float m_FrameDuration { 0.1f };

	bool m_isPlaying { true };
	bool m_isFlipped { false };

	bool m_isLooping { true };
	bool m_hasPlayedOnce { false };
};
